﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WpfDesktopEdition;
using System.Drawing;
using System.Collections.ObjectModel;

namespace Post9837_WPFOverlayDrawWithGeoCanvasParameter
{
    class cGeoServer
    {

        public byte[] getImage(string BoundingBox, int width, int height, GeographyUnit mapUnit)
        {

            ShapeFileFeatureLayer worldLayer = new ShapeFileFeatureLayer(@"..\..\App_Data\Countries02.shp");
            worldLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = AreaStyles.CreateSimpleAreaStyle(GeoColor.SimpleColors.Transparent, GeoColor.FromArgb(100, GeoColor.SimpleColors.Blue));
            worldLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            worldLayer.Open();

            BitmapTileCache oTileCache = new FileBitmapTileCache(@"..\..\App_Data\layerOverlayDrawWithCache\\", "ManualCache");
            GdiPlusGeoCanvas geoCanvas = new GdiPlusGeoCanvas();
            RectangleShape WordExtent = new RectangleShape(BoundingBox);
            Bitmap MapImage = new Bitmap(width, height);
            System.IO.MemoryStream ImageStream = new System.IO.MemoryStream();

            oTileCache.TileMatrix.Scale = ExtentHelper.GetScale(WordExtent, width, mapUnit);
            var tiles = oTileCache.GetTiles(WordExtent);
            foreach (var tile in tiles)
            {

                Bitmap nativeImage = new Bitmap(oTileCache.TileMatrix.TileWidth, oTileCache.TileMatrix.TileHeight);

                try
                {
                    if (tile.Bitmap == null)
                    {
                        GdiPlusGeoCanvas tempGeoCanvas = new GdiPlusGeoCanvas();
                        tempGeoCanvas.BeginDrawing(nativeImage, tile.BoundingBox, mapUnit);
                        Collection<SimpleCandidate> tempLabelCandidates = new Collection<SimpleCandidate>();

                        lock (worldLayer)
                        {
                            if (!worldLayer.IsOpen) worldLayer.Open();
                            tempGeoCanvas.Flush();
                            worldLayer.Draw(tempGeoCanvas, tempLabelCandidates);
                        }
                        tempGeoCanvas.EndDrawing();
                        tile.Bitmap = nativeImage;
                        oTileCache.SaveTile(tile);
                    }

                    //..is there a smarter way to draw the tiles direct to the canvas?????
                    tile.Bitmap.Save(ImageStream, System.Drawing.Imaging.ImageFormat.Png);

                    PointShape centerPoint = tile.BoundingBox.GetCenterPoint();
                    ScreenPointF screenPoint = ExtentHelper.ToScreenCoordinate(tile.BoundingBox, centerPoint, tile.Bitmap.Width, tile.Bitmap.Height );
                    GeoImage TileImage = new GeoImage(ImageStream);

                    geoCanvas.BeginDrawing(MapImage, WordExtent, mapUnit);
                    geoCanvas.DrawScreenImage(TileImage, screenPoint.X, screenPoint.Y, tile.Bitmap.Width, tile.Bitmap.Height , DrawingLevel.LevelOne, 0, 0, 0);
                    geoCanvas.EndDrawing();
                    //..
                 
                }
                finally
                {
                    nativeImage.Dispose();
                }

            }

            MapImage.Save(ImageStream, System.Drawing.Imaging.ImageFormat.Png);
            return ImageStream.ToArray();
            
        }
    }
}
